package com.bjorsond.android.timeline.reflectionspace;

import java.util.List;

import org.jivesoftware.smack.SmackConfiguration;

import de.imc.mirror.sdk.DataObject;
import de.imc.mirror.sdk.DataObjectListener;
import de.imc.mirror.sdk.OfflineModeHandler.Mode;
import de.imc.mirror.sdk.android.ConnectionConfiguration;
import de.imc.mirror.sdk.android.ConnectionConfigurationBuilder;
import de.imc.mirror.sdk.android.ConnectionHandler;
import de.imc.mirror.sdk.android.DataHandler;
import de.imc.mirror.sdk.android.DataObjectBuilder;
import de.imc.mirror.sdk.android.Space;
import de.imc.mirror.sdk.android.SpaceHandler;
import de.imc.mirror.sdk.exceptions.ConnectionStatusException;
import de.imc.mirror.sdk.exceptions.UnknownEntityException;
import android.app.Activity;
import android.content.Context;
import android.util.Log;

public class TestFuck extends Activity{
	static String domain = "mirror-server-ntnu";
	static String appID = "TimelineApplication";
	static String serverIP = "129.241.103.122";
	static int port = 5222;
	
	static String testSpaceID = "team#73";
	
	public static void connectToServer(Context context){
		SmackConfiguration.setPacketReplyTimeout(10000);
		ConnectionConfigurationBuilder builder = new ConnectionConfigurationBuilder(domain, appID);
		builder.setHost(serverIP);
		builder.setPort(port);
		ConnectionConfiguration connectionConfig = builder.build();

		String userName = "taimlain";
		String password = "timetest";
		
		ConnectionHandler connectionHandler = new ConnectionHandler(userName, password, connectionConfig);
		
		try{
			connectionHandler.connect();
		} catch(ConnectionStatusException e){
			Log.w("COULD NOT CONNECT", e);
		}
		

		SpaceHandler spaceHandler = new SpaceHandler(context, connectionHandler, "offlineDB");
		spaceHandler.setMode(Mode.ONLINE);
		
		
		//Data handler
		DataHandler dataHandler = new DataHandler(connectionHandler, spaceHandler);
		dataHandler.setMode(Mode.ONLINE);
		
		Space reflectionSpace = (Space) spaceHandler.getSpace(testSpaceID);
		Space myPrivateSpace = spaceHandler.getDefaultSpace();
		try {
			dataHandler.registerSpace(myPrivateSpace.getId());
		} catch (UnknownEntityException e) {
			e.printStackTrace();
		}
		DataObjectListener myListener = new DataObjectListener() {
			public void handleDataObject(DataObject dataObject, String spaceId) {
				String objectId = dataObject.getId();
				Log.i("Received object ", objectId + " from space " + spaceId);
			}
		};
		dataHandler.addDataObjectListener(myListener);
		
		
		//Create the data object using the object builder
		DataObjectBuilder dataObjectBuilder = new DataObjectBuilder("foo", "mirror:application:"+appID+":foo");
		dataObjectBuilder.addElement("bar", "drit og lort", false);
		DataObject dataObject = dataObjectBuilder.build();

		if(dataObject.getId()!=null) Log.i("ID of object published", dataObject.getId());

//		try {
//			dataHandler.publishDataObject(dataObject, reflectionSpace.getId());
//		} catch (UnknownEntityException e) {
//			e.printStackTrace();
//		}
		Log.i("Publish object", "Attempted to published on space "+reflectionSpace.getName()+", no exceptions cathed.");
		
		
		List<DataObject> allObjectsFromSpace = null;
		try {
			allObjectsFromSpace = dataHandler.retrieveDataObjects(myPrivateSpace.getId());
			
			//Logging things for debugging purposes
			List<de.imc.mirror.sdk.Space> handledSpaces = dataHandler.getHandledSpaces();
			if(!handledSpaces.isEmpty()){
				Log.i("Size of handledSpaces", handledSpaces.size()+"");
				for(int i=0; i<handledSpaces.size(); i++){
					Log.i("Spaces handled by datahandler", handledSpaces.get(i).getName().toString());
				}
			}else Log.i("NO SPACES HANDLED BY DATAHANDLER LOL", "WTF");
			Log.i("Mode of dataHandler", dataHandler.getMode().toString());
		} catch (UnknownEntityException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		Log.i("Size of all objects gotten from space before return", allObjectsFromSpace.size()+"");
		for(int i=0; i<allObjectsFromSpace.size(); i++){
			Log.i("Object gotten", allObjectsFromSpace.get(i)+"");
		}
	}
}
